; names of new keywords for ProWesS Sbasic interface
; Link in the new keyword names into the interpreter
; v. 1.03 	1996 Oct 11 10:49:06
;  W. Lenerz   1996
; the definiton enforcing section is Copyright QJUMP

	section	text

	xdef	the_beginning
	xdef	LinkedDLL
	xref	version
	xref	dd_link,pf_link
	xref	ddprocs,pfprocs

bv_ntbas	equ	$18	name table
bv_ntp	equ	$1c
bv_nlbas	equ	$20	name list

the_beginning

	BSR	dd_link		; link in datadesign keywords
	LEA	ddprocs,A0
	BSR.S	enforce		; enforce their definitions
	BSR	pf_link		; link in proforma keywords
	LEA	pfprocs,A0
	BSR.S	enforce		; enforce their definitions
	MOVE.W	$110,A2
	LEA	procs,A1		; link in prowess keywords
	JSR	(A2)
	LEA	procs,A0		; enforce defns & leave


*
*	ENFORCE THE NEW DEFINITIONS OF THE POINTER TOOLKIT, IN CASE
*	THE SYSTEM STILL THINKS THEY'RE SUPERBASIC ROUTINES.
*
* on entry, A0 points to the new definitions


enforce	ADDQ.L	#2,A0		; point past number of procs
enf2	MOVE.W	#$0800,D5 ; set type = procedure
*
nt_bpfl	MOVE.L	A0,A5		; keep address of the procedure
	MOVE.W	(A0)+,D0		; get next offset
	BNE.S	nt_sadd		; there is one, so set address ->...
	BSET	#8,D5		; else, change from procs to fns
	BNE.S	NT_EXIT		; we've done that before, so stop now
	ADDQ.L	#2,A0		; skip function count
	BRA.S	nt_bpfl		; and see if there are any fns ->...

nt_sadd	ADD.W	D0,A5		; A5 points to next address
	MOVEQ	#0,D6		; initialise
	MOVE.B	(A0)+,D6		; length of name
	MOVE.L	bv_ntbas(A6),A3	; get name table address

nt_entry	MOVE.L	(A6,A3.L),D0	; address for this entry in name table
	BEQ.S	nt_next		; this entry in table is empty->..
	MOVE.L	bv_nlbas(A6),A1	; A1 = name list
	ADD.W	D0,A1		; address of name
	MOVEQ	#0,D0
	MOVE.B	(A6,A1.L),D0	; length of this name in name table
	ADDQ.L	#1,A1		; point after length of name
	MOVE.L	A0,A2		; point to name in my procedure list
	CMP.B	D0,D6		; same length?
	BRA.S	nam_lend	; test it->...

nam_loop	MOVEQ	 #$FFFFFFDF,D1	; mask for uppercase
	AND.B	(A6,A1.L),D1	; name in table - into upper case
	ADDQ.W	#1,A1		; point to next char
	CMP.B	(A2)+,D1		; same?

nam_lend	DBNE	D0,nam_loop	; dec & branch until NE (!)
	BEQ.S	nt_set		; if this was still EQ, it is this name
*
nt_next				; name not found, try next one
	ADDQ.L	#8,A3		; next name table entry
	CMP.L	bv_ntp(A6),A3	; last?
	BLT.S	nt_entry		; ... no take the next
	BRA.S	nt_bpfe		; yes, do the next procedure
*
; here we found the name to treat
nt_set	MOVE.W	D5,(A6,A3.L)	; set name type (mc proc/fn)
	MOVE.L	A5,4(A6,A3.L)	; set procedure address
	MOVE.L	A0,A2		; name address
	MOVE.B	D6,D0		; number of characters
	SUB.W	D6,A1		; backspace to start

nm_loop	MOVE.B	(A2)+,(A6,A1.L)	; move characters, to be sure the...
	ADDQ.L	#1,A1		; ...case is exactly as in the keyword
	SUBQ.B	#1,D0
	BGT.S	nm_loop
*
nt_bpfe
	BSET	#0,D6		; skip any padding character (!)
	ADD.W	D6,A0		; and skip the name
	BRA.S	nt_bpfl		; and do next of my procedures
*
NT_EXIT
	MOVEQ	#0,D0
	RTS
*

LinkedDLL   dc.b	  0

*--------- two macros only needed here --------------------------------

; macro to define keyword, where name & name of routine differ
kwrddiff macro	routine,name
	xref	[routine]_rout
	dc.w	[routine]_rout-*
	dc.b	[.len(name)]+8
	dc.b	'[name]_ROUTINE'
	endm

kwrddiffx macro	 routine,name
	xref	[routine]
	dc.w	[routine]-*
	dc.b	[.len(name)]
	dc.b	'[name]'
	endm


; macro to define keywords where name & name of routine are the same
kwrd	macro	name
	xref	[name]
	dc.w	[name]-*
	dc.b	[.len(name)]
	dc.b	'[name]'
	endm

*----------------------------------------------------------------------

procs	DC.W	20		 ; "nbr" of commands
	kwrd	PWremove
	kwrd	PWchange
	kwrd	PWquit
	kwrd	PWconfig
	kwrd	PWoutln
	kwrd	PWbreak
	kwrd	PWscrsize
	kwrd	GSET
	kwrd	GDEL
	kwrd	GFRST
	kwrd	GNEXT
	kwrd	MKLEN
	kwrd	MKLEN0
	kwrd	PWsprite
	kwrd	LoadPWdefn
	kwrd	PWcolourQuery
	dc.w	0
	dc.w	70		; 'nbr' of functions
	kwrd	PW
	kwrd	PWcreate
	kwrd	PWactivate
	kwrd	PWquery
	kwrd	MKSPRT
	kwrd	PWtest
	kwrd	PWversion
	kwrd	pwcfg
	kwrddiffx pwchangef,PWchange%
	kwrddiff	hit,HIT
	kwrddiff	do,DO
	kwrddiff	rd,RDRW
	kwrddiff	ex,EXIT
	kwrddiff	mo,MOVE
	kwrddiff	sc,SCALE
	kwrddiff	dh,DRAGH
	kwrddiff	dd,DRAGD
	kwrddiff	de,DRAGE
	kwrddiff	da,DRAGA
	kwrddiff	in,INFO
	kwrddiff	wa,WAKE
	kwrddiff	qu,QUIT
	kwrddiff	he,HELP
	kwrddiff	it,INIT
	kwrddiff	e1,EVT1
	kwrddiff	e2,EVT2
	kwrddiff	e3,EVT3
	kwrddiff	e4,EVT4
	kwrddiff	e5,EVT5
	kwrddiff	e6,EVT6
	kwrddiff	e7,EVT7
	kwrddiff	e8,EVT8

	kwrd	MKSTRING$
	kwrd	ERRSTR$
	kwrddiffx errstr$,ERR_STR$	; allow both types of name!
	kwrd	GGET
	kwrd	IS_OPEN
	DC.L	0

	dc.b	'ProWesS SBasic Interface '
	dc.b	'Version '
	DC.L	version		; this will generate a warning
	dc.w	' Copyright (c) W. Lenerz 1996'
	end
